# $Revision: 1.34 $, $Date: 2011/09/27 19:11:59 $
#
# Conditional build:
%bcond_without	dbus	# build without dbus support
%bcond_without	bluez	# build without Bluetooth support
#
Summary:	Service daemon for mediating access to a GPS
Summary(pl.UTF-8):	Oprogramowanie komunikujące się z GPS-em
Name:		gpsd
Version:	3.1
Release:	1
License:	BSD
Group:		Daemons
Source0:	http://download.berlios.de/gpsd/%{name}-%{version}.tar.gz
# Source0-md5:	f280b914c19da3a91aa5e67d83d35033
Patch0:		%{name}-link.patch
Patch1:		%{name}-qt.patch
URL:		http://gpsd.berlios.de/
BuildRequires:	QtNetwork-devel >= 4.4
%if %{with dbus}
BuildRequires:	dbus-devel
BuildRequires:	dbus-glib-devel
%endif
%{?with_bluez:BuildRequires:	bluez-libs-devel}
BuildRequires:	docbook-dtd412-xml
BuildRequires:	docbook-style-xsl
BuildRequires:	libstdc++-devel
BuildRequires:	libusb-devel >= 1.0.0
BuildRequires:	libxslt-progs
BuildRequires:	ncurses-devel
BuildRequires:	pkgconfig
BuildRequires:	python-devel >= 1:2.4
BuildRequires:	scons >= 1.2.1
BuildRequires:	sed >= 4.0
BuildRequires:	qt4-qmake >= 4.4
BuildRequires:	rpm-pythonprov
BuildRequires:	xmlto
Requires:	%{name}-libs = %{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# libgpsd expects gpsd_report() defined by user
# libQgpsmm expects libgps_dump_state(gps_data_t*) 
%define		skip_post_check_so	libgpsd\.so.* libQgpsmm\.so.*

%description
gpsd is a service daemon that mediates access to a GPS sensor
connected to the host computer by serial or USB interface, making its
data on the location/course/velocity of the sensor available to be
queried on TCP port 2947 of the host computer. With gpsd, multiple GPS
client applications (such as navigational and wardriving software) can
share access to a GPS without contention or loss of data. Also, gpsd
responds to queries with a format that is substantially easier to
parse than NMEA 0183. A client library is provided for applications.

After installing this RPM, gpsd will automatically connect to USB
GPSes when they are plugged in and requires no configuration. For
serial GPSes, you will need to start gpsd by hand. Once connected, the
daemon automatically discovers the correct baudrate, stop bits, and
protocol. The daemon will be quiescent when there are no clients
asking for location information, and copes gracefully when the GPS is
unplugged and replugged.

%description -l pl.UTF-8
gpsd to demon usługi pośredniczącej w dostępie do sensora GPS
połączonego z komputerem poprzez interfejs szeregowy lub USB,
udostępniający dane o położeniu, kierunku ruchu i prędkości z sensora
na porcie TCP 2947 komputera. Przy użyciu gpsd wiele aplikacji
klienckich GPS (takich jak oprogramowanie nawigacyjne) może
współdzielić dostęp do GPS-a bez utraty danych. Ponadto gpsd odpowiada
na zapytania w formacie znacznie łatwiejszym do przetworzenia niż NMEA
0183. Dostarczona jest biblioteka kliencka dla aplikacji.

Po zainstalowaniu tego pakietu gpsd będzie się automatycznie łączył z
GPS-ami USB po podłączeniu ich. Dla GPS-ów szeregowych trzeba
uruchomić gpsd ręcznie. Po poączeniu demon automatycznie wykrywa
właściwą prędkość, liczbę bitów stopu i protokół. Demon oczekuje
spokojnie kiedy nie ma klientów i radzi sobie dobrze z odłączaniem i
ponownym podłączaniem GPS-a.

%package -n udev-gpsd
Summary:	UDEV support for GPS hotplugging
Summary(pl.UTF-8):	Obsługa UDEV-a do podłączania urządzeń GPS
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}
Requires:	udev-core >= 1:127

%description -n udev-gpsd
UDEV support for GPS hotplugging.

%description -n udev-gpsd -l pl.UTF-8
Obsługa UDEV-a do podłączania urządzeń GPS.

%package libs
Summary:	GPSd client library
Summary(pl.UTF-8):	Biblioteka kliencka GPSd
Group:		Libraries

%description libs
GPSd client library.

%description libs -l pl.UTF-8
Biblioteka kliencka GPSd.

%package devel
Summary:	Client libraries in C and Python for talking to a running gpsd or GPS
Summary(pl.UTF-8):	Biblioteki klienckie dla C i Pythona do komunikacji z gpsd lub GPS-em
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	libstdc++-devel
Obsoletes:	gpsd-static

%description devel
This package provides C header files for the gpsd shared libraries
that manage access to a GPS for applications; also Python modules. You
will need to have gpsd installed for it to work.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe C dla bibliotek współdzielonych
gpsd zarządzających dostępem do GPS-a dla aplikacji, a także moduły
Pythona. Do działania bibliotek potrzebny jest gpsd.

%package qt-libs
Summary:	GPS Qt4 integration library
Summary(pl.UTF-8):	Biblioteka integrująca GPS z Qt4
Group:		X11/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	QtNetwork >= 4.4

%description qt-libs
GPS Qt4 integration library.

%description qt-libs -l pl.UTF-8
Biblioteka integrująca GPS z Qt4.

%package qt-devel
Summary:	Development files for GPS Qt4 integration library
Summary(pl.UTF-8):	Pliki programistyczne biblioteki integrującej GPS z Qt4
Group:		X11/Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Requires:	%{name}-qt-libs = %{version}-%{release}
Requires:	QtNetwork-devel >= 4.4

%description qt-devel
Development files for GPS Qt4 integration library.

%description qt-devel -l pl.UTF-8
Pliki programistyczne biblioteki integrującej GPS z Qt4.

%package -n python-gps
Summary:	Python GPSd client library
Summary(pl.UTF-8):	Biblioteka kliencka GPSd dla Pythona
Group:		Libraries/Python
Requires:	%{name}-libs = %{version}-%{release}

%description -n python-gps
GPSd client library for Python.

%description -n python-gps -l pl.UTF-8
Biblioteka kliencka GPSd dla Pythona.

%package clients
Summary:	Clients for gpsd
Summary(pl.UTF-8):	Aplikacje klienckie dla gpsd
Group:		Applications/System
Requires:	%{name}-libs = %{version}-%{release}

%description clients
cgps is a simple test client for gpsd. It displays current GPS
position/time/velocity information and (for GPSes that support the
feature) the locations of accessible satellites. cgps resembles xgps,
but without the pictorial satellite display. It can run on a serial
terminal or terminal emulator.

%description clients -l pl.UTF-8
cgps to prosty klient testowy dla gpsd. Wyświetla bieżące informacje
GPS o położeniu, czasie i prędkości oraz (w przypadku GPS-ów
obsługujących to) położenia dostępnych satelitów. Jest podobny do
xgps, ale nie ma rysunkowego przedstawiania satelitów. Może działać na
terminalu szeregowym lub emulatorze terminala.

%package clients-gui
Summary:	Clients for gpsd with an X interface
Summary(pl.UTF-8):	Aplikacje klienckie z interfejsem X
Group:		Applications/System
Requires:	%{name}-libs = %{version}-%{release}
Requires:	python-gps = %{version}-%{release}
Requires:	python-pygtk-gtk >= 2:2.0

%description clients-gui
xgps is a simple test client for gpsd with an X interface. It displays
current GPS position/time/velocity information and (for GPSes that
support the feature) the locations of accessible satellites.

xgpsspeed is a speedometer that uses position information from the
GPS.

%description clients-gui -l pl.UTF-8
xgps to prosty klient testowy dla gpsd z interfejsem X. Wyświetla
bieżące informacje GPS o położeniu, czasie i prędkości oraz (w
przypadku GPS-ów obsługujących to) położenia dostępnych satelitów.

xgpsspeed to prędkościomierz używający informacji o położeniu z GPS-a.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

# make .egg-info in builddir
%{__sed} -i -e 's/^\(build = .*\)\])$/\1, python_egg_info])/' SConstruct

%build
export CC="%{__cc}"
export CXX="%{__cxx}"
export CFLAGS="%{rpmcflags}"
export CXXFLAGS="%{rpmcxxflags}"
export CPPFLAGS="%{rpmcppflags} -I/usr/include/ncurses $(pkg-config --cflags dbus-1)"
export LDFLAGS="%{rpmldflags}"
%scons \
	%{!?with_bluez:bluez=False} \
	%{?with_dbus:dbus_export=True}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_datadir}/%{name},/lib/udev/rules.d,/etc/sysconfig}

# must install manually
# or great scons would recompile everything
install -d $RPM_BUILD_ROOT{%{_bindir},%{_sbindir},%{_includedir},%{_libdir},%{_pkgconfigdir},%{_mandir}/man{1,3,5,8},%{py_sitedir}/gps}
install cgps gegps gpscat gpsctl gpsdecode gpsfake gpsmon gpspipe gpsprof gpxlogger lcdgps xgps xgpsspeed $RPM_BUILD_ROOT%{_bindir}
install gpsd gpsdctl $RPM_BUILD_ROOT%{_sbindir}
cp -p cgps.1 gegps.1 gps.1 gpscat.1 gpsctl.1 gpsdecode.1 gpsfake.1 gpsmon.1 gpspipe.1 gpsprof.1 lcdgps.1 xgps.1 xgpsspeed.1 $RPM_BUILD_ROOT%{_mandir}/man1
cp -p gpsd_json.5 srec.5 $RPM_BUILD_ROOT%{_mandir}/man5
cp -p gpsd.8 gpsdctl.8 $RPM_BUILD_ROOT%{_mandir}/man8
cp -p gps.h gpsd.h libgpsmm.h $RPM_BUILD_ROOT%{_includedir}
cp -dp lib{Qgpsmm,gps,gpsd}.so{,.??,.*.*.*} $RPM_BUILD_ROOT%{_libdir}
for f in libgps.pc libgpsd.pc ; do
	%{__sed} -e 's,@VERSION@,%{version},;s,@prefix@,%{_prefix},;s,@libdir@,/%{_lib},' ${f}.in >$RPM_BUILD_ROOT%{_pkgconfigdir}/${f}
done
cp -p libQgpsmm.3 libgps.3 libgpsd.3 libgpsmm.3 $RPM_BUILD_ROOT%{_mandir}/man3
cp -p gps-%{version}.egg-info $RPM_BUILD_ROOT%{py_sitedir}
install gps/*.so $RPM_BUILD_ROOT%{py_sitedir}/gps
cp -p gps/*.py $RPM_BUILD_ROOT%{py_sitedir}/gps

install gpsd.hotplug $RPM_BUILD_ROOT/lib/udev
install gpsd.rules $RPM_BUILD_ROOT/lib/udev/rules.d/25-gpsd.rules
#install packaging/rpm/gpsd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/gpsd
#install packaging/rpm/gpsd.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/gpsd
install dgpsip-servers $RPM_BUILD_ROOT%{_datadir}/gpsd/dgpsip-servers

# check if missing header installation is up to date
[ ! -f $RPM_BUILD_ROOT%{_includedir}/libQgpsmm_global.h ] || exit 1
install libQgpsmm_global.h $RPM_BUILD_ROOT%{_includedir}

[ ! -d $RPM_BUILD_ROOT%{_desktopdir} ] || exit 1
install -d $RPM_BUILD_ROOT{%{_desktopdir},%{_pixmapsdir}}
install packaging/X11/{xgps,xgpsspeed}.desktop $RPM_BUILD_ROOT%{_desktopdir}
install packaging/X11/gpsd-logo.png $RPM_BUILD_ROOT%{_pixmapsdir}

%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%post	qt-libs -p /sbin/ldconfig
%postun	qt-libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc README INSTALL COPYING TODO AUTHORS
%attr(755,root,root) %{_bindir}/gpsmon
%attr(755,root,root) %{_sbindir}/gpsd
%attr(755,root,root) %{_sbindir}/gpsdctl
%{_mandir}/man1/gpsmon.1*
%{_mandir}/man8/gpsd.8*
%{_mandir}/man8/gpsdctl.8*
%dir %{_datadir}/gpsd
%{_datadir}/gpsd/dgpsip-servers

%files -n udev-gpsd
%defattr(644,root,root,755)
%attr(755,root,root) /lib/udev/gpsd.hotplug
#/lib/udev/rules.d/25-gpsd.rules
#%attr(754,root,root) /etc/rc.d/init.d/gpsd
#%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/gpsd

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgpsd.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgpsd.so.20
%attr(755,root,root) %{_libdir}/libgps.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgps.so.20

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/gpsdecode
%attr(755,root,root) %{_libdir}/libgps.so
%attr(755,root,root) %{_libdir}/libgpsd.so
%{_includedir}/gps.h
%{_includedir}/gpsd.h
%{_includedir}/libgpsmm.h
%{_pkgconfigdir}/libgps.pc
%{_pkgconfigdir}/libgpsd.pc
%{_mandir}/man1/gpsdecode.1*
%{_mandir}/man3/libgps.3*
%{_mandir}/man3/libgpsd.3*
%{_mandir}/man3/libgpsmm.3*
%{_mandir}/man5/gpsd_json.5*
%{_mandir}/man5/srec.5*

%files qt-libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libQgpsmm.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libQgpsmm.so.20

%files qt-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libQgpsmm.so
%{_includedir}/libQgpsmm_global.h
%{_mandir}/man3/libQgpsmm.3*
# missing in scons build
#%{_libdir}/libQgpsmm.prl
#%{_pkgconfigdir}/Qgpsmm.pc

%files -n python-gps
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/gegps
%attr(755,root,root) %{_bindir}/gpscat
%attr(755,root,root) %{_bindir}/gpsfake
%attr(755,root,root) %{_bindir}/gpsprof
%dir %{py_sitedir}/gps
%attr(755,root,root) %{py_sitedir}/gps/*.so
%{py_sitedir}/gps/*.py[co]
%{py_sitedir}/gps-%{version}.egg-info
%{_mandir}/man1/gegps.1*
%{_mandir}/man1/gpscat.1*
%{_mandir}/man1/gpsfake.1*
%{_mandir}/man1/gpsprof.1*

%files clients
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/gpsctl
%attr(755,root,root) %{_bindir}/cgps
%attr(755,root,root) %{_bindir}/gpspipe
%{?with_dbus:%attr(755,root,root) %{_bindir}/gpxlogger}
%{_mandir}/man1/gpsctl.1*
%{_mandir}/man1/cgps.1*
%{_mandir}/man1/gps.1*
%{_mandir}/man1/gpspipe.1*

%files clients-gui
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/lcdgps
%attr(755,root,root) %{_bindir}/xgps
%attr(755,root,root) %{_bindir}/xgpsspeed
%{_mandir}/man1/lcdgps.1*
%{_mandir}/man1/xgps.1*
%{_mandir}/man1/xgpsspeed.1*
%{_desktopdir}/xgps.desktop
%{_desktopdir}/xgpsspeed.desktop
%{_pixmapsdir}/gpsd-logo.png

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: gpsd.spec,v $
Revision 1.34  2011/09/27 19:11:59  qboosh
- updated to 3.1, uses scons now
- most of build/install rewritten (we all know scons is great...)
- link patch replaced by new one, added qt patch
- static libs are gone

Revision 1.33  2011/09/01 17:05:24  arekm
- release 3

Revision 1.32  2011/08/31 18:30:12  arekm
- release 2

Revision 1.31  2011/03/25 15:10:34  qboosh
- updated to 2.96 (note: new libgps and libQgpsmm sonames)
- updated link patch
- removed obsolete python patch

Revision 1.30  2011/01/16 08:38:06  qboosh
- release 3

Revision 1.29  2011/01/16 08:21:26  qboosh
- updated link patch to fix libgpsd linking (with libusb); dropped wrong skip_post_check_so
- added desktop patch, install desktops and pixmap
- moved udev files to udev-gpsd package

Revision 1.28  2011/01/15 22:57:34  qboosh
- enabled bluetooth by default

Revision 1.27  2011/01/15 22:56:51  qboosh
- added python patch for "make version" to work properly (instead of using dumb make message as .egg-info filename)
- separated -qt-{libs,devel}
- updated link patch to kill -lnsl
- updated X deps

Revision 1.26  2010/11/24 14:23:05  hawk
- added required skip_post_check_so

Revision 1.25  2010/11/05 10:57:40  caleb
- Up to 2.95

Revision 1.24  2010/08/18 11:13:41  glen
- fix -libs packaging; rel 2

Revision 1.23  2010/07/08 18:23:33  arekm
- rel 1; builds

Revision 1.22  2010/05/26 14:49:53  caleb
- Up to 2.94
- BR: docbook-style-xsl
- Packaged missing libraries

Revision 1.21  2010/05/13 15:23:32  sparky
- BR: docbook-dtd412-xml, libstdc++-devel, libxslt-progs, pkgconfig, xmlto

Revision 1.20  2010/03/28 03:00:53  wrobell
- ver. 2.92
- ncurses patch replaced with CPPFLAGS switch
- udev merged with the sources

Revision 1.19  2009/10/20 21:51:53  arekm
- rel 3; wrapper should be executable

Revision 1.18  2009/07/05 18:42:20  arekm
- rel 2; parallel build broken

Revision 1.17  2009/06/08 11:49:14  paszczus
- updated to 2.39

Revision 1.16  2009/01/05 00:36:21  glen
- adapter, udev 127 with /lib; rel 1

Revision 1.15  2008/09/29 18:33:44  qboosh
- fixed x bcond, separated -clients-gui
- python-dependent clients moved to python-gps subpackage
- include ghost soname symlink instead of killing it

Revision 1.14  2008/09/29 18:06:32  qboosh
- partial cleanup
- .pc files moved to -devel

Revision 1.13  2008/09/24 14:23:16  mguevara
- rel 0.8, added gpsd-udev.patch, added x bcond for test-build in the AC
  environment, not ready yet - when you plug a GPS device in a /dev/gpsX
  appears but you have to run gpsd by hand

Revision 1.12  2008/07/22 16:54:04  qboosh
- unified, .so perms

Revision 1.11  2008/07/22 08:16:07  jajcus
- python-gps package added
- cleanup in %install

Revision 1.10  2008/06/12 17:24:29  qboosh
- updated _appdefsdir for X11R7
- dbus bcond fixes

Revision 1.9  2008-06-12 17:15:07  deejay1
- up to 2.37
- added TODO, NFY and NIHTDTTD (no idea how to do the todo-at least point 2)

Revision 1.8  2008-02-08 13:53:44  jajcus
- BR: xorg-lib-libXaw-devel instead of XFree86-devel

Revision 1.7  2007-02-13 07:16:47  glen
- tabs in preamble

Revision 1.6  2007/02/12 00:48:54  baggins
- converted to UTF-8

Revision 1.5  2006/09/17 20:59:52  bartowl
- updated to 2.33, STBR

Revision 1.4  2005/12/03 16:27:17  qboosh
- openmotif-libs dep is autodetected

Revision 1.3  2005/12/03 16:10:37  qboosh
- pl, separated -libs and -static, some cleanups

Revision 1.2  2005/12/01 15:07:08  abram
- cleanups
- sorted BR
- disabled ldconfig in post and postun
- deleted files libgps.a and libgps.la

Revision 1.1  2005/11/28 19:15:19  abram
- initial
- please forgive me, this is first spec, first commit ...
